/* E10's assembler. */

/* MODIFIED TO WRITE OUTPUT FILE FOR REWITE 4 */

#include <stdio.h>
#include <string.h>
#include "op.c"
#include "op.h"

int main( int argc, char *argv[] ){
char string[128];
char string1[128];
char string2[128];
char buffer[256];
char opcode[256];
char acstr[256];
char indstr[256];
char addrstr[256];
FILE *infile;
FILE *outfile;
int opc,pass_reqd,pass2;
unsigned long word_lo,word_hi;
unsigned long ac,ind,addr;
int linepos,y,z,x,linectr;
unsigned long memaddr;
int varcnt;
char varname[16384][8];
unsigned long varvalue[16384];

unsigned long long ll_buffer;		/* ADDED */
unsigned long long make_word(unsigned long hi, unsigned long lo);

printf("E10ASM 6\n");

x=0;

if(argc==3){
	strcpy(string1,argv[1]);
	strcpy(string2,argv[2]);
	printf("Reading %s, assembling to %s\n",string1,string2);
	goto open_files;
	}

printf("INPUT FILENAME? ");
gets(string1);

printf("OUTPUT FILENAME? ");
gets(string2);

open_files:

if(!(infile=fopen(string1,"r"))){
	printf("Error opening input file\n");
	exit(1);
	}

if(!(outfile=fopen(string2,"w"))){
	printf("Error opening output file\n");
	fclose(infile);
	exit(2);
	}

pass2_entry:
linepos=0;x=0;y=0;linectr=0;memaddr=0;

loop1:
	/* Read an input line */
	fgets(buffer,256,infile);
	linectr++;

/* Skip blank lines. */
	if(strlen(buffer)==1){
		printf("IGNORING BLANK LINE\n");
		goto eloop1;
		}

while(buffer[linepos] != ' '){
	if(linepos >= strlen(buffer)){ opcode[y]=0; break; }
	if(buffer[linepos]=='\n'){ addrstr[y]=0; break; }
	opcode[y]=buffer[linepos];
	linepos++;
	y++;
	}
opcode[y]=0;
y=0;linepos++;

/* Now check for AC */

while(buffer[linepos] != ' '){
	if(linepos >= strlen(buffer)){ acstr[y]=0; break; }
	if(buffer[linepos]=='\n'){ addrstr[y]=0; break; }
	acstr[y]=buffer[linepos];
	linepos++;
	y++;
	}
acstr[y]=0;
ac=strtoul(acstr,NULL,8);
linepos++;y=0;

/* Check I and X */

while(buffer[linepos] != ' '){
	if(linepos >= strlen(buffer)){ indstr[y]=0; break; }
	if(buffer[linepos]=='\n'){ addrstr[y]=0; break; }
	indstr[y]=buffer[linepos];
	linepos++;
	y++;
	}

indstr[y]=0;
ind=strtoul(indstr,NULL,8);
linepos++;y=0;

/* Get Y */
while(buffer[linepos] != ' '){
	if(linepos >= strlen(buffer)){ addrstr[y]=0; break; }
	if(buffer[linepos]=='\n'){ addrstr[y]=0; break; }
	addrstr[y]=buffer[linepos];
	linepos++;
	y++;
	}
addrstr[y]=0;
addr=strtoul(addrstr,NULL,8);

y=0;
/* We have the opcode */
z=0;

while(z<0777){
	if(!strcmp(opcode,op_str[z])){
		/* printf("OPCODE is %s,# %o\n",op_str[z],z); */
		opc=z;
		break;
		}
	z++;
	}
	if(!strncmp(opcode,".",1)){
	opc=0;
	}

/* Illegal instruction? */

if(opc==0){
	if(!strncmp(opcode,"CONO",4)){
		word_hi=0700200;
		word_hi=word_hi|(ac<<6);
		printf("CONO WORD HI %lo, AC << 8 %lo\n",word_hi,ac<<8);
		if(ind != 0){
			word_hi=word_hi|ind;
			}
		word_lo=addr;
		printf("CONO WORD HI %lo AC %lo\n",word_hi,ac);
		goto opdone;
		}
	if(!strncmp(opcode,"CONI",4)){
		word_hi=0700240;
		word_hi=word_hi|(ac<<6);
		if(ind > 0){
			word_hi=word_hi|ind;
			}
		word_lo=addr;
		goto opdone;
		}
	if(!strncmp(opcode,"DATAO",5)){
		word_hi=0700140;
		word_hi=word_hi|(ac<<6);
		if(ind > 0){
			word_hi=word_hi|ind;
			}
		word_lo=addr;
		goto opdone;
		}
	if(!strncmp(opcode,"DATAI",5)){
		word_hi=0700040;
		word_hi=word_hi|(ac<<6);
		if(ind > 0){
			word_hi=word_hi|ind;
			}
		word_lo=addr;
		goto opdone;
		}
	if(!strncmp(opcode,"CONSZ",5)){
		word_hi=0700300;
		word_hi=word_hi|(ac<<6);
		if(ind > 0){
			word_hi=word_hi|ind;
			}
		word_lo=addr;
		goto opdone;
		}
	if(!strncmp(opcode,"CONSO",5)){
		word_hi=0700340;
		word_hi=word_hi|(ac<<6);
		if(ind > 0){
			word_hi=word_hi|ind;
			}
		word_lo=addr;
		goto opdone;
		}
	if(!strncmp(opcode,"BLKO",5)){
		word_hi=0700100;
		word_hi=word_hi|(ac<<6);
		if(ind > 0){
			word_hi=word_hi|ind;
			}
		word_lo=addr;
		goto opdone;
		}
	if(!strncmp(opcode,"BLKI",5)){
		word_hi=0700000;
		word_hi=word_hi|(ac<<6);
		if(ind > 0){
			word_hi=word_hi|ind;
			}
		word_lo=addr;
		goto opdone;
		}
	if(!strncmp(opcode,"$",1)){
		/* Declaring a variable */
		varcnt++;
		/* Suck in variable name */
		x=0;y=0;
		while(x<=strlen(opcode)){
			varname[varcnt][y]=opcode[x];
			x++;y++;
			}
		varname[varcnt][x]=0;
		/* Now, are we defining it, or using it as a label? */
		if(!strncmp(acstr,"=",1)){
			/* Setting it - variable = ind */
			varvalue[varcnt]=ind;
			printf("VARIABLE %i NAME %s VALUE %lo\n",varcnt,varname[varcnt],varvalue[varcnt]);
			goto eloop1;
			}
		if(!strncmp(acstr,":",1)){
			/* Lable - variable = memaddr */
			varvalue[varcnt]=memaddr;
			printf("LABEL %i NAME %s VALUE %lo\n",varcnt,varname[varcnt],varvalue[varcnt]);
			goto eloop1;
			}
		printf("UH OH, YOU'RE NOT SUPPOSED TO GET HERE (VAR PARSE ERROR?)\n");
		goto eloop1;
		}
	if(!strncmp(opcode,".BLOCK",6)){
		printf(".BLOCK\n");
		x=0;
		word_hi=0;
		word_lo=0;
		while(x<ac){
			ll_buffer=make_word(word_hi,word_lo);			
			fwrite(&ll_buffer,8,1,outfile);
			memaddr++;
			x++;
			}
		goto eloop1;
		}
	if(!strncmp(opcode,".WORD",5)){
		printf(".WORD\n");
		word_hi=ind;
		word_lo=addr;
		ll_buffer=make_word(word_hi,word_lo);
		fwrite(&ll_buffer,8,1,outfile);
		memaddr++;
		goto eloop1;
		}
	if(!strcmp(opcode,".ASCII")){
		printf(".ASCII\n");
		x=7;
		while(x<strlen(buffer)){
			word_hi=0;
			word_lo=buffer[x];
			ll_buffer=make_word(word_hi,word_lo);
			fwrite(&ll_buffer,8,1,outfile);
			memaddr++;
			x++;
			}
		goto eloop1;
		}
	if(!strcmp(opcode,".LOC")){
		printf(".LOC\n");
		fseek(outfile,8*ac,SEEK_SET);
		memaddr=ac;
		goto eloop1;
		}

	printf("?UNDEFINED OPCODE, LINE %d, %s\n",linectr,buffer);
	}

/* Form the word */
word_hi=0;
word_lo=0;

/* WORD: 012345678 9012 3 4567 890123456789012345 */
/*        OPCODE    AC  I  X    Y		  */

word_hi=word_hi|(opc<<9);
word_hi=word_hi|(ac<<5);
if(ind > 0){
	word_hi=word_hi|ind;
	}
word_lo=addr;

if(!strncmp(addrstr,"$",1)){
	/* Refrencing a variable */
	x=1;
	while(x<=varcnt){
		printf("CHECKING %s against %s\n",varname[x],addrstr);
		/* Look up the variable */
		if(!strcmp(varname[x],addrstr)){
			/* We matched */
			printf("MATCHED VARIABLE %s\n",varname[x]);
			word_lo=varvalue[x];
			printf("USING %lo\n",word_lo);
			goto opdone;
			}
		x++;
		}
	if(pass2==1){
		printf("FATAL: UNRESOLVED VAR ON 2ND PASS, %s\n",addrstr);
		exit(2);
		}
	printf("COULDN'T MATCH VARIABLE %s, SETTING FOR 2ND PASS\n",addrstr);
	pass_reqd=1;
	}

/* printf("Output word is %lo %lo\n",word_hi,word_lo); */

opdone:

/* Write that */
ll_buffer=make_word(word_hi,word_lo);
fwrite(&ll_buffer,8,1,outfile);

memaddr++;

eloop1:
printf("LOC %lo\n",memaddr);
if(feof(infile)){
		goto end;
		}

/* I'm paranoid */
x=0;y=0;z=0;linepos=0;opc=0;
buffer[1]=0;
opcode[1]=0;
goto loop1;

end:
if(pass_reqd==1){
	printf("Making second pass\n");
	fseek(infile,0,SEEK_SET);
	fseek(infile,0,SEEK_SET);
	pass2=1; pass_reqd=0;
	goto pass2_entry;
	}

printf("Done.  Cleaning up\n");

fclose(infile);
fclose(outfile);
exit(0);

}

unsigned long long make_word(unsigned long hi, unsigned long lo){
	unsigned long long ll_buffer;

	ll_buffer=hi;
	ll_buffer=ll_buffer<<18;
	ll_buffer=ll_buffer|lo;
	return(ll_buffer);
	}
